PROGRAM SEUIL(INPUT,OUTPUT,ENTREE,LIENS);
CONST NBCAR=10;
      LANG=1;         (* Parametre de langue: 1 = FRANCAIS
                         Language parameter : 2 = ENGLISH  *** a venir *** *)
(* ======================================================================= *)
(* Ce programme lit une matrice binaire de type SIMIL et cree un lien      *)
(* (fichier LIENS) pour toute valeur S >= un seuil fixe par l'utilisateur  *)
(* ou pour toute valeur D <= la valeur-seuil.                              *)
(* Cette liste de liens, calculee a partir d'une matrice de distances      *)
(* geographiques, peut servir  raliser,  l'aide des programmes BIOGEO   *)
(* ou K-MEANS, des groupements restreints par une taille de voisinage      *)
(* definie par l'usager.                                                   *)
(*                                             Pierre Legendre, avril 1995 *)
(* ======================================================================= *)

TYPE VARIABLE= RECORD CASE INTEGER OF
               1:(INT:INTEGER);
               2:(RE:REAL);
               3:(CAR:PACKED ARRAY[1..NBCAR] OF CHAR);
               END;
VAR LIENS: TEXT;
    coupe:real;
    nliens,SouD:integer;
    ENTREE: FILE OF VARIABLE;
    VAL: VARIABLE;

PROCEDURE TypeSIMIL;         (* Lecture d'une matrice S ou D de type SIMIL *)
CONST NBMOTS=1;
VAR  I,J,NOBJ,NBVAR,compte:INTEGER;

   PROCEDURE ECRITDATA;
   VAR I,J,K:INTEGER;
   BEGIN
   J:=0;
   FOR I:=1 TO NBMOTS DO
      BEGIN
      VAL:=ENTREE@;GET(ENTREE);
      FOR K:=1 TO NBCAR DO
            BEGIN
            J:=J+1;
            IF J<=10 THEN WRITE(VAL.CAR [K]);
            END;
      END;
   END;  (* Fin de ECRITDATA *)

   PROCEDURE LITDATA;
   VAR I,J,K:INTEGER;
   BEGIN
   J:=0;
   FOR I:=1 TO NBMOTS DO
      BEGIN
      VAL:=ENTREE@;GET(ENTREE);
      END;
   END;  (* Fin de LITDATA *)

BEGIN
RESET(ENTREE);
WRITELN('FICHIER D''ENTREE:');
VAL:=ENTREE@;GET(ENTREE);
NOBJ:=VAL.INT;	        (* NOBJ: nombre de lignes de la matrice de donnees *)
WRITELN('    NOMBRE D''OBJETS: ',NOBJ:4);            (* Impression de NOBJ *)
VAL:=ENTREE@;GET(ENTREE);
NBVAR:=VAL.INT;	                              (* NBVAR: nombre de colonnes *)
WRITELN('    NOMBRE DE VARIABLES: ',NBVAR:4);       (* Impression de NBVAR *)
WRITE  ('    TITRE: ');
FOR I:=1 TO 10 DO ECRITDATA;                        (* Impression du titre *)
WRITELN;
WRITE  ('    DATE: ');
ECRITDATA;	                                      (* Impression de la date *)
WRITELN;
WRITE  ('    MESURE DE RESSEMBLANCE: ');
ECRITDATA;ECRITDATA;	        (* Impression de la mesure de ressemblance *)
WRITELN;
WRITELN; 
VAL:=ENTREE@;GET(ENTREE);  (* Lecture du nombre didentificateurs presents *)
IF VAL.INT<> 0 THEN	                        (* Lecture des identificateurs *)
      BEGIN
      FOR I:=1 TO NOBJ DO
            BEGIN
            FOR J:=1 TO NBMOTS DO LITDATA;         (* Lecture des identif. *)
            WRITELN;
	    END;
      END;
compte:=0;
if SouD=1 then
   begin                                    (* pour matrice de Similarites *)
   FOR I:=1 TO NOBJ DO	           (*  Lecture des valeurs de ressemblance *)
      BEGIN
      FOR J:=I+1 TO NOBJ DO
         BEGIN
         VAL:=ENTREE@;GET(ENTREE);
         if val.re >= coupe then 
            begin
            write(liens,i:5,j:5);
            nliens:=nliens+1;
            compte:=compte+1;
            if compte=8 then
               begin
               writeln(liens);
               compte:=0;
               end;
            end;
         end;
      end;
   end
   else begin                                 (* pour matrice de Distances *)
   FOR I:=1 TO NOBJ DO	           (*  Lecture des valeurs de ressemblance *)
      BEGIN
      FOR J:=I+1 TO NOBJ DO
         BEGIN
         VAL:=ENTREE@;GET(ENTREE);
         if val.re <= coupe then 
            begin
            write(liens,i:5,j:5);
            nliens:=nliens+1;
            compte:=compte+1;
            if compte=8 then
               begin
               writeln(liens);
               compte:=0;
               end;
            end;
         end;
      end;
   end;
writeln(liens);
writeln('Nombre de liens satisfaisant le seuil choisi =',nliens:8);writeln;
END;

BEGIN
REWRITE(liens);
nliens:=0;
SouD:=0;
WRITELN('Est-ce une matrice de similarites (S) ou de distances (D) ?');
WHILE NOT (INPUT@ IN ['S','s','D','d']) DO GET(INPUT);
IF INPUT@ IN ['S','s'] THEN SouD:=1;readln;
WRITELN('Seuil de coupure?');
readln(coupe);
if SouD=1 then WRITELN('Un lien sera cree si S >= ',coupe:10:5)
else WRITELN('Un lien sera cree si D <= ',coupe:10:5);
writeln;
TypeSIMIL;
WRITELN('Fin du programme.');
END.
