PROGRAM DENDRO(ENTREEC,SORTIEP,FICHTRI,SORTIEC,INPUT,OUTPUT);
LABEL 777;
CONST NOBJ=280;
      MAXNOBJ=512;
      MAXNOBJ1=513;      (* =MAXNOBJ+1 *)
      MAXNOBJ3=793;      (* NOBJ+MAXNOBJ+1 *)
      MAXNOBJ4= 2048;    (* LIMITE BUFFER  *)
      MAXCORR=150;       (* LIM  POUR TESTS A POSTERIORI *)
      MAXSIM=11175;      (* MAXCORR X (MAXCORR-1)/2  *)
      NBMOTS=1;
      NBCAR=10;
      NBSETS=4;          (* (NBSETS+1)X NBBITS >=NOBJ *)
      NBBITS=59;
      NBBITSL1=58;
      FACTMULT=16384;
      NBITER=1000;
      NBMATS=10000;
      MAXBUF=5000;       (* LENGTH OF THE VECTOR TO INVERT *)
      ESPACE=' ';
      TIRET ='-';
      EXCLAM='|';
      LANG=1;            (* PARAMETRE DE LANGUE: 1=FRANCAIS
                            LANGUAGE PARAMETER:  2=ENGLISH  *)
(* ================================================================== *)
(*    ENTREEC is the input SIMIL file (same file as ENTREEB in        *)
(*            LANCE, INTERLNK (LIENSINT), and SORTRI)                 *)
(*    SORTIEP is the output of LANCE and INTERLNK (LIENSINT).         *)
(*            It is a binary file, and it tells DENDRO how the        *)
(*            dendrogram is to be constructed.                        *)
(*    FICHTRI is the sorted similarity file produced by SORTRI.       *)
(*            It is required for a posteriori testing.                *)
(*    SORTIEC is the output file containing the dendrogram            *)
(*            and the a posteriori tests.                             *)
(*    INPUT and OUTPUT are the user's terminal.                       *)
(* ================================================================== *)
 
TYPE ENSEMBLE=SET OF 0..NBBITSL1;
TYPE NOEUD=RECORD
           RESULTAT:REAL;
           PTRGAUCHE,PTRDROIT:INTEGER;
           END;
     VARIABLE=RECORD CASE INTEGER OF
              1:(INT:INTEGER);
              2:(RE:REAL);
              3:(CAR:PACKED ARRAY [1..NBCAR] OF CHAR);
              END;
     ENS=SET OF 0..NBBITSL1;
     MATENS=ARRAY[0..NBSETS] OF ENS;
     TRIE     =RECORD
               RESULTAT:REAL;
               INT:INTEGER;
               END;
     MATCARD =RECORD
              MATDIST:TRIE;
              MATBITG,MATBITD:MATENS;
              END;
     MATBTYP=ARRAY[MAXNOBJ..MAXNOBJ3]OF MATCARD;
     MATBPTR=@MATBTYP;
     MATINT=ARRAY[-1..NOBJ] OF INTEGER;
     PTRMATINT=@MATINT;
     NOEUDTYP=ARRAY[1..MAXNOBJ3] OF RECORD
              PTRGG,PTRGD,PTRDG,PTRDD:INTEGER;
              END;
     PTRNOEUD=@NOEUDTYP;
       TESTTYP=ARRAY[MAXNOBJ1..MAXNOBJ3] OF REAL;
     PTRTEST=@TESTTYP;
     REC=RECORD R1,R2:REAL;END;
     DATA=ARRAY[1..MAXBUF] OF TRIE;
     PTRDATA=@DATA;
     MATTRI=ARRAY[1..MAXNOBJ4] OF INTEGER;
     PTRMATTRI=@MATTRI;
     MATREEL=ARRAY[1..NOBJ] OF REAL;
      MATSIM1=ARRAY[1..MAXSIM] OF  INTEGER;
      PTRMATSIM=@MATSIM1;
VAR I,J,K,OBJ,DIMENSION,NBOBJ,NBFAITS,LIMITE,NBLIGNES,NBPTRS:INTEGER;
    PAS,MIN:REAL;
    TITRE,LIENSPRI,TESTGR,TESTAPOSTERIORI:BOOLEAN;
    TEMP:VARIABLE;
    PTRDONNEE:PTRDATA;
    MAT:ARRAY[MAXNOBJ..MAXNOBJ3]OF NOEUD;
    VALEUR,MATENTROPIE:MATREEL;
    MATSIM:PTRMATSIM;
    TRIMAT:PTRMATTRI;
    MATBITS:MATBPTR;
    MATFORTES:ARRAY[1..NOBJ]OF MATENS;
    MATOCC,MATPTR,PTRPTR,POSITION:PTRMATINT;
    TEST:PTRTEST;
    MATNOEUD:PTRNOEUD;
    IDENTIFICATEUR:ARRAY[1..NOBJ] OF PACKED ARRAY[1..10] OF CHAR;
    SORTIEP:FILE OF NOEUD;
    FICHTRI,FICHTR2:FILE OF TRIE;
    ENTREEC:FILE OF VARIABLE;
    SORTIEC:TEXT;
 
(* FUNCTION GGUBFS(VAR X:REC):REAL;FORTRAN;      for the IMSL version *)
FUNCTION GGUBFS (VAR DSEED:REAL):REAL;
CONST D2P31M=2147483647.0;
      D2P31 =2147483648.0;
VAR A:REAL;
BEGIN
A:=16807*DSEED;
DSEED:=A-TRUNC(A/D2P31M)*D2P31M;
GGUBFS:=DSEED/D2P31;
END;                 (* end of the PASCAL version of GGUBFS, May 1987 *)
 
FUNCTION CARD(A:ENSEMBLE):INTEGER;
VAR I,COMPTE:INTEGER;
BEGIN
COMPTE:=0;
FOR I:=0 TO NBBITSL1 DO IF I IN A THEN
   COMPTE:=COMPTE+1;
CARD:=COMPTE;
END;
 
PROCEDURE INVERSE(VAR MAT:DATA);
VAR I,J,K,NBBUFS,NBCALCULS:INTEGER;
 
   PROCEDURE COPIE(LIMITE:INTEGER);
   VAR I:INTEGER;
   BEGIN
   FOR I:=LIMITE DOWNTO 1 DO
      BEGIN
      FICHTR2@:=MAT[I];
      PUT(FICHTR2);
      END;
   END;   (* COPIE *)
 
   PROCEDURE LECTURE(LIMITE:INTEGER);
   VAR I:INTEGER;
   BEGIN
   FOR I:=1 TO LIMITE DO
      BEGIN
      MAT[I]:=FICHTRI@;GET(FICHTRI);
      END;
   END;    (* LECTURE *)
 
BEGIN
RESET(ENTREEC);
REWRITE(FICHTR2);
NBCALCULS:=NBOBJ*(NBOBJ-1) DIV 2;
NBBUFS:=(NBCALCULS) DIV MAXBUF;
FOR I:=NBBUFS DOWNTO 1 DO
      BEGIN
      RESET(FICHTRI);
      FOR J:=2 DOWNTO I DO
      FOR K:=1 TO MAXBUF DO GET(FICHTRI);
      LECTURE(MAXBUF);
      COPIE(MAXBUF);
      END;
RESET(FICHTRI);
FOR I:=1 TO NBBUFS DO
   FOR J:=1 TO MAXBUF DO GET(FICHTRI);
LECTURE(NBCALCULS MOD MAXBUF);
COPIE(NBCALCULS MOD MAXBUF);
END;   (* INVERSE *)
 
PROCEDURE SHELLSORT(VAR A: MATREEL;N: INTEGER);
LABEL 1;
VAR I,J,K,L,M,O: INTEGER;
    W:REAL;
BEGIN
M:=2*N-1 DIV 2;
WHILE M<>0 DO
        BEGIN
        K:=N-M;
        FOR J:=1 TO K DO
                BEGIN
                I:=J;
                WHILE I>=1 DO
                        BEGIN
                        IF A[I+M]>=A[I] THEN GOTO 1;
                        O:=I+M;
                        W:=A[I];A[I]:=A[O];A[O]:=W;
                        I:=I-M;
                        END;
1:                 END;
        M:=M  DIV 2;
        END;
END;        (* FIN DE SHELLSORT *)
 
 (*********************************************************************)
 (*            TEST A POSTERIORI                                      *)
 (*********************************************************************)
PROCEDURE TESTS(VAR PTRPTR:MATINT);
VAR I,J,K,OBJ:INTEGER;
    TEMP:VARIABLE;
    X:REAL;
 
PROCEDURE SHELL(VAR A: MATTRI;N: INTEGER);
LABEL 1;
VAR I,J,K,L,M,O,W: INTEGER;
BEGIN
M:=2*N-1 DIV 2;
WHILE M<>0 DO
        BEGIN
        K:=N-M;
        FOR J:=1 TO K DO
                BEGIN
                I:=J;
                WHILE I>=1 DO
                        BEGIN
                        IF A[I+M]>=A[I] THEN GOTO 1;
                        O:=I+M;
                        W:=A[I];A[I]:=A[O];A[O]:=W;
                        I:=I-M;
                        END;
1:                 END;
        M:=M  DIV 2;
        END;
END;        (* FIN DE SHELLSORT *)
 
PROCEDURE CORRELATIONS(VAR MAT:MATTRI;VAR COMPTEUR:MATINT);
VAR I,J,REFE,PTR,PP,P,S,L1,L2,P1,P2,NBVUS,LONGUEUR,MAXIMUM:INTEGER;
    X,XX,YY,X2,Y,Y2,XY:REAL;
    TRI:TRIE;
      PROCEDURE CALCULCORR;
      VAR I,J:INTEGER;
      BEGIN
      IF LONGUEUR>1 THEN SHELL(MAT,LONGUEUR);
      PTR:=0;
      MAT[LONGUEUR+1]:=0;
      FOR I:=1 TO LONGUEUR DO
            BEGIN
            IF MAT[I+1]<>MAT[I] THEN
                  BEGIN
                  PP:=0;
                  REFE:=MAT[I];
                  FOR J:=REFE+1 TO NBLIGNES DO PP:=PP+COMPTEUR[J];
                  P:=P+(PP)*(I-PTR);
                  COMPTEUR[REFE]:=COMPTEUR[REFE]+I-PTR;
                  PP:=0;
                  FOR J:=REFE-1 DOWNTO 1 DO PP:=PP+COMPTEUR[J];
                  S:=S+(PP-PTR)*(I-PTR);
                  PTR:=I;
                  END;
            END;
      L1:=L1+(LONGUEUR*(LONGUEUR-1));
      LONGUEUR:=0;
      END;  (* CALCULCORR *)
 
BEGIN   (* CORRELATIONS *)
WRITELN(SORTIEC);
IF LANG=1 THEN WRITELN(SORTIEC,' CORRELATIONS COPHENETIQUES')
          ELSE WRITELN(SORTIEC,' COPHENETIC CORRELATIONS   ');
FOR I:=1 TO NBLIGNES DO COMPTEUR[I]:=0;
RESET(FICHTRI);
P:=0;S:=0;X:=0;X2:=0;Y:=0;Y2:=0;XY:=0;
MAXIMUM:=NBOBJ*(NBOBJ-1) DIV 2;
TRI:=FICHTRI@; GET(FICHTRI);
XX:=TRI.RESULTAT;
P1:=TRI.INT;
P2:=P1 MOD FACTMULT;
P1:=P1 DIV FACTMULT-1;
P1:=P1*(P1-1) DIV 2+P2;
P2:=MATSIM@[P1];
Y:=VALEUR[P2];
Y2:=Y*Y;
X:=TRI.RESULTAT;
X2:=X*X;
XY:=X*Y;
LONGUEUR:=0;
L1:=0;L2:=0;
FOR NBVUS:=2 TO MAXIMUM DO
      BEGIN
      LONGUEUR:=LONGUEUR+1;
      MAT[LONGUEUR]:=MATSIM@[P1];
      IF XX<>FICHTRI@.RESULTAT THEN CALCULCORR;
      TRI:=FICHTRI@; GET(FICHTRI);
      IF LONGUEUR=MAXNOBJ4 THEN
            BEGIN
IF LANG=1 THEN WRITELN(' FIN DES CALCULS: TROP DE VALEURS LIEES DANS',
                       ' LE FICHIER DE SIMILARITES')
          ELSE WRITELN(' END OF COMPUTATIONS: TOO MANY TIED VALUES IN',
                       ' THE SIMILARITY FILE');
            GOTO 777;
            END;
      XX:=TRI.RESULTAT;
      X:=X+XX;
      X2:=X2+XX*XX;
      P1:=TRI.INT;
      P2:=P1 MOD FACTMULT;
      P1:=P1 DIV FACTMULT-1;
      P1:=P1*(P1-1) DIV 2 +P2;
      P2:=MATSIM@[P1];
      YY:=VALEUR[P2];
      Y:=Y+YY;
      Y2:=Y2+YY*YY;
      XY:=XY+XX*YY;
      END;
LONGUEUR:=LONGUEUR+1;
MAT[LONGUEUR]:=P2;
CALCULCORR;
FOR I:=1 TO NBLIGNES DO L2:=L2+COMPTEUR[I]*(COMPTEUR[I]-1);
P1:=MAXIMUM*(MAXIMUM-1) DIV 2;
L2:=L2 DIV 2;
L1:=L1 DIV 2;
XX:=SQRT(P1-L1);
YY:=SQRT(P1-L2);
IF LANG=1 THEN BEGIN
WRITELN(SORTIEC,'    TAU B DE KENDALL ',(P-S)/(XX*YY):10:5);
(* WRITELN(SORTIEC,'    TAU C            ',(P-S)*2*NBLIGNES/
                             (NBLIGNES-1)/(MAXIMUM*MAXIMUM):10:5); *)
WRITELN(SORTIEC,'    R DE PEARSON     ',
    (XY-(X*Y)/MAXIMUM)/SQRT((X2-X*X/MAXIMUM)*(Y2-Y*Y/MAXIMUM)):10:5);
WRITELN(SORTIEC,'    DISTANCE DE GOWER',X2+Y2-2*XY:10:5);
WRITELN(SORTIEC);
WRITELN(SORTIEC,' Coefficients d''efficacite');
WRITELN(SORTIEC);
WRITELN(SORTIEC,'            Niveau  Entropie    delta    1/delta  ');
END ELSE BEGIN
WRITELN(SORTIEC,'    KENDALL''S TAU B ',(P-S)/(XX*YY):10:5);
(* WRITELN(SORTIEC,'              TAU C ',(P-S)*2*NBLIGNES/
                              (NBLIGNES-1)/(MAXIMUM*MAXIMUM):10:5); *)
WRITELN(SORTIEC,'    PEARSON''S R     ',
    (XY-(X*Y)/MAXIMUM)/SQRT((X2-X*X/MAXIMUM)*(Y2-Y*Y/MAXIMUM)):10:5);
WRITELN(SORTIEC,'    GOWER''S DISTANCE',X2+Y2-2*XY:10:5);
WRITELN(SORTIEC);
WRITELN(SORTIEC,' Efficiency coefficients');
WRITELN(SORTIEC);
WRITELN(SORTIEC,'            Level    Entropy    delta    1/delta  ');
END;
WRITELN(SORTIEC,' -------------------------------------------------');
(* XX:=0;
FOR I:=NBLIGNES DOWNTO 1 DO
      BEGIN
      X:=MATENTROPIE[I];
      XX:=X+XX;
      WRITELN(SORTIEC,'        ',1-VALEUR[I]:10:5,XX:10:5);
      WRITELN(SORTIEC,ESPACE:28,X:10:5,1/X:10:5);
      END; *)
XX:=LN(NBOBJ); (* Modification 1.0.1 *)
WRITELN(SORTIEC,'        ',0.0:10:5,xx:10:5);
FOR I:=NBLIGNES DOWNTO 1 DO
      BEGIN
      X:=MATENTROPIE[I]/NBOBJ;
      XX:=XX-X;                                         (* Niveau = D *)
      WRITELN(SORTIEC,'        ',1-VALEUR[I]:10:5,' ':10,X:10:5,1/X:10:5);
      WRITELN(SORTIEC,ESPACE:18,XX:10:5);
      END;
END;    (* CORRELATIONS *)

BEGIN   (* TESTS A POSTERIORI *)
NEW(TRIMAT);
CORRELATIONS(TRIMAT@,PTRPTR);
DISPOSE(TRIMAT);
DISPOSE(MATSIM);
END;    (* TESTS A POSTERIORI *)
 
(* **************************************************************** *)
(*              TEST SUR LES GROUPES                                *)
(********************************************************************)
PROCEDURE TESTSGROUPES(VAR TEST:TESTTYP;VAR POSITION:MATINT;
                     VAR MATNOEUD:NOEUDTYP);
VAR I,J,K,NIVEAU,NBPTRS,LIMENSG,LIMENSD:INTEGER;
(* REC0:REC;                         for the IMSL version of GGUBFS *)
   REC0:REAL; (* for the version of GGUBFS included in this program *)
   PROCEDURE FEUILLE(I:INTEGER);
   BEGIN
   NBOBJ:=NBOBJ+1;
   POSITION[I]:=NBOBJ;
   WITH MATNOEUD[I] DO
         BEGIN
         PTRDD:=NBOBJ;
         PTRGG:=NBOBJ;
         END;
   END;   (* FIN FEUILLE *)
 
   PROCEDURE NOEUDGAUCHE(I:INTEGER);
   BEGIN
   WITH MAT[I] DO
         BEGIN
         MATNOEUD[I].PTRGG:=MATNOEUD[PTRGAUCHE].PTRGG;
         MATNOEUD[I].PTRGD:=MATNOEUD[PTRGAUCHE].PTRDD;
         END;
   END;
 
   PROCEDURE NOEUDDROIT(I:INTEGER);
   BEGIN
   WITH MAT[I] DO
         BEGIN
         MATNOEUD[I].PTRDG:=MATNOEUD[PTRDROIT ].PTRGG;
         MATNOEUD[I].PTRDD:=MATNOEUD[PTRDROIT ].PTRDD;
         END;
   END;
 
   PROCEDURE INIT(I:INTEGER;DROIT:BOOLEAN);
   VAR J:INTEGER;
   BEGIN
   IF I>MAXNOBJ THEN WITH MAT[I] DO
         BEGIN
         INIT(PTRGAUCHE,FALSE);
         NOEUDGAUCHE(I);
         INIT(PTRDROIT,TRUE);
         NOEUDDROIT(I);
         END
   ELSE FEUILLE(I);
   END;          (* FIN INIT *)
 
   FUNCTION COMB(A,B:INTEGER):REAL;
   VAR I:INTEGER;
       X:REAL;
   BEGIN
   X:=0;
   FOR I:=A-B+1 TO A DO X:=X+LN(I);
   FOR I:=1 TO B DO X:=X-LN(I);
   COMB:=EXP(X);
   END;   (* FIN COMB *)
 
      FUNCTION CARDENS(VAR REF1,REF2:MATENS):INTEGER;
      VAR J,K:INTEGER;
      BEGIN
      K:=0;
      FOR J:=LIMENSG TO LIMENSD DO K:=K+CARD(REF1[J]*REF2[J]);
      CARDENS:=K;
      END;
 
      PROCEDURE NULL(VAR REF1:MATENS);
      VAR I:INTEGER;
      BEGIN
      FOR I:=LIMENSG TO LIMENSD DO REF1[I]:=[];
      END;
 
      PROCEDURE PLUS(VAR REF1:MATENS;I:INTEGER);
      VAR J,K:INTEGER;
      BEGIN
      J:= I DIV NBBITS;
      K:= I MOD NBBITS;
      REF1[J]:=REF1[J]+[K];
      END;
 
      PROCEDURE ENLEVE(VAR REF1:MATENS;I:INTEGER);
      VAR J:INTEGER;
      BEGIN
      J:=I DIV NBBITS;
      REF1[J]:=REF1[J]-[I MOD NBBITS];
      END;
 
      FUNCTION MEMBRE(VAR REF1:MATENS;I:INTEGER):BOOLEAN;
      BEGIN
      MEMBRE:=(I MOD NBBITS) IN (REF1[I DIV NBBITS]);
      END;
 
   FUNCTION H(VALG,VALD,N1,N2:INTEGER;VAR REF1,REFINIT:MATENS):REAL;
   VAR I,J,K,T,NB,PP,PG,EQ,COMPTEUR:INTEGER;
       EQ1:REAL;
 
      PROCEDURE MOINS(VAR REF1,REF2,REF3:MATENS);
      VAR I:INTEGER;
      BEGIN
      FOR I:=LIMENSG TO LIMENSD DO REF1[I]:=REF2[I]-REF3[I];
      END;
 
      FUNCTION COMPARE(REF1:MATENS):INTEGER;
      VAR I,J:INTEGER;
          REF2:MATENS;
      BEGIN
      NULL(REF2);
      J:=0;
      MOINS(REF2,REFINIT,REF1);
      FOR I:=VALG TO VALD DO IF MEMBRE(REF1,I) THEN
         BEGIN
         J:=J+CARDENS(MATFORTES[I],REF2);
         END;
      COMPARE:=J;
      IF J<NB THEN PP:=PP+1
      ELSE IF J> NB THEN PG:=PG+1
           ELSE EQ:=EQ+1;
      END;   (* FIN COMPARE *)
 
      PROCEDURE DISTRIBUTION(I,J:INTEGER);
      VAR K:INTEGER;
      BEGIN
      FOR K:= I TO J DO
            BEGIN
            PLUS(REF1,K);
            IF J=VALD THEN COMPTEUR:=COMPARE(REF1)
            ELSE DISTRIBUTION(K+1,J+1);
            ENLEVE(REF1,K);
            END;
      END;   (* FIN DISTRIBUTION *)
 
   BEGIN  (* H *)
   COMPTEUR:=0;
   NB:=COMPARE(REF1);
   NULL(REF1);
   PP:=0;PG:=0;EQ:=0;
   IF N1>N2 THEN
         BEGIN
         I:=N2;
         N2:=N1;
         N1:=I;
         END;
   EQ1:=COMB(N1+N2,N1);
   IF EQ1<=NBMATS THEN
         BEGIN
         DISTRIBUTION(VALG,VALD-N1+1);
         H:=(PG+EQ)/(PP+EQ+PG);
         END
   ELSE
         BEGIN
         T:=VALD-VALG+1;
         FOR I:=1 TO NBITER DO
               BEGIN
               NULL(REF1);
               K:=0;
               WHILE K<N1 DO
                     BEGIN
                     J:=TRUNC(GGUBFS(REC0)*T)+VALG;
                     IF NOT(MEMBRE(REF1,J)) THEN
                           BEGIN
                           K:=K+1;
                           PLUS(REF1,J);
                           END;
                    END;
               J:=COMPARE(REF1);
               END;
         EQ1:=EQ+(PP+EQ+PG)/EQ1;
         H:=(PG+EQ1)/(PP+EQ1+PG);
         END;
   END;       (* FIN H *)
 
   PROCEDURE VALIDENOEUD;
   VAR I,J,NECESSAIRE,ALPHA,OBJ1,OBJ2,CARD1,CARD2,LONGLIST:INTEGER;
       X:REAL;
       TRIREC:TRIE;
       FAIT:ARRAY[MAXNOBJ1..MAXNOBJ3] OF BOOLEAN;
       REF1,REFINIT:MATENS;
       TERMINE:BOOLEAN;
   BEGIN
(* REC0.R1:=0.318309886;REC0.R2:=0;         for the IMSL version of GGUBFS *)
   REC0:=0.318309886;(* for the version of GGUBFS included in this program *)
   FOR I:=1 TO 40 DO X:=GGUBFS(REC0);
   LIMENSG:=0;
   LIMENSD:=NBOBJ DIV NBBITS;
   FOR I:=MAXNOBJ1 TO OBJ DO FAIT[I]:=FALSE;
   REPEAT
         TERMINE:=TRUE;
         LIMENSG:=0;LIMENSD:=NBOBJ DIV NBBITS;
         FOR I:=1 TO NBOBJ DO NULL(MATFORTES[I]);
         RESET(FICHTR2);
         TRIREC:=FICHTR2@;
         FOR I:=MAXNOBJ1 TO OBJ DO
               BEGIN
               IF NOT(FAIT[I]) THEN WITH MATNOEUD[I] DO
                     BEGIN
                     CARD1:=PTRGD-PTRGG+1;
                     CARD2:=PTRDD-PTRDG+1;
                     LIMENSG:=PTRGG DIV NBBITS;
                     LIMENSD:=PTRDD DIV NBBITS;
                     NECESSAIRE:=(CARD1+CARD2-1)*(CARD1+CARD2) DIV 2;
                     ALPHA:=0;
                     NULL(REF1);
                     FOR J:=PTRGG TO PTRGD DO PLUS(REF1,J);
                     NULL(REFINIT);
                     FOR J:=PTRGG TO PTRDD DO PLUS(REFINIT,J);
                     FOR J:=PTRGG TO PTRDD DO
                           ALPHA:=ALPHA+CARDENS(REFINIT,MATFORTES[J]);
                     IF ALPHA <= NECESSAIRE THEN
                       BEGIN
                       WHILE ((ALPHA < NECESSAIRE)
                             OR(TRIREC.RESULTAT=FICHTR2@.RESULTAT)) DO
                             BEGIN
                             TRIREC:=FICHTR2@;
                             GET(FICHTR2);
                             WITH TRIREC DO
                                   BEGIN
                                   OBJ1:=POSITION[INT DIV FACTMULT];
                                   OBJ2:=POSITION[INT MOD FACTMULT];
                                   END;
                             PLUS(MATFORTES[OBJ1],OBJ2);
                             PLUS(MATFORTES[OBJ2],OBJ1);
                             IF ((MEMBRE(REFINIT,OBJ1))
                                 AND(MEMBRE(REFINIT,OBJ2))) THEN
                                   ALPHA:=ALPHA+2;
                             END;
                       IF CARD1*CARD2 =1 THEN TEST[I]:=-1
                  ELSE TEST[I]:=H(PTRGG,PTRDD,CARD1,CARD2,REF1,REFINIT);
                       FAIT[I]:=TRUE;
                       END
                     ELSE TERMINE:=FALSE;
                     END;
               END;
   UNTIL TERMINE;
   END;    (* FIN VALIDE NOEUD *)
 
BEGIN (* TESTS *)
NBOBJ:=0;
FOR I:=MAXNOBJ TO OBJ DO
NBPTRS:=0;
INIT(OBJ,FALSE);
VALIDENOEUD;
END;    (* FIN TESTS *)
 
 (********************************************************************)
 (*              LIENS PRIMAIRES                                     *)
 (********************************************************************)
PROCEDURE LIENSPRIMAIRES(VAR MATBITS:MATBTYP);
VAR I,J,K:INTEGER;
 
   PROCEDURE AJOUTE(VAR REF1:MATENS;I:INTEGER);
   VAR J,K:INTEGER;
   BEGIN
   FOR J:=0 TO DIMENSION DO REF1[J]:=[];
   J:= I DIV NBBITS;
   K:= I MOD NBBITS;
   REF1[J]:=REF1[J]+[K];
   END;
 
   PROCEDURE PLUS(VAR REF1:MATENS;I:INTEGER);
   VAR J:INTEGER;
   BEGIN
   WITH MATBITS[I] DO
   FOR J:=0 TO DIMENSION DO REF1[J]:=MATBITG[J]+MATBITD[J];
   END;
 
   FUNCTION MEMBRE(VAR REF1:MATENS;I:INTEGER):BOOLEAN;
   BEGIN
   MEMBRE:=(I MOD NBBITS) IN (REF1[I DIV NBBITS]);
   END;
 
   PROCEDURE ARBORESCENCE(I:INTEGER;VAR ENSEMBLE:MATENS);
   VAR X:REAL;
   BEGIN
   IF I>MAXNOBJ THEN WITH MAT[I] DO
         BEGIN
         ARBORESCENCE(PTRGAUCHE,MATBITS[I].MATBITG);
         ARBORESCENCE(PTRDROIT,MATBITS[I].MATBITD);
         PLUS(ENSEMBLE,I);
         END
   ELSE  AJOUTE(ENSEMBLE,I);
   END;      (* FIN ARBORESCENCE *)
 
   PROCEDURE CALCULEDIST;
   VAR I,J,GAUCHE,DROITE,ADDRBIT1,ADDRBIT2,ADDRSET1,ADDRSET2:INTEGER;
       VALEUR:TRIE;
 
      FUNCTION CANDIDAT:BOOLEAN;
      BEGIN
      IF  (ADDRBIT1 IN MATFORTES[GAUCHE,ADDRSET1]) THEN CANDIDAT:=FALSE
      ELSE CANDIDAT:=TRUE;
      END;
 
      FUNCTION MEMBRE(VAR MATBIT:MATENS):BOOLEAN;
      BEGIN
    IF((ADDRBIT1 IN MATBIT[ADDRSET1])AND(ADDRBIT2 IN MATBIT[ADDRSET2]))
         THEN
         MEMBRE:=TRUE
      ELSE MEMBRE:=FALSE;
      END;   (* FIN MEMBRE *)
 
      PROCEDURE AJUSTE(I:INTEGER);
      VAR J,K,L:INTEGER;
      BEGIN
      WITH MATBITS[I] DO
         BEGIN
         MATDIST:=VALEUR;
         K:=0;
         FOR L:=1 TO NBOBJ DO
               BEGIN
               IF L MOD NBBITS=0 THEN K:=K+1;
               IF L MOD NBBITS IN MATBITG[K] THEN
                  FOR J:=0 TO DIMENSION DO
                   MATFORTES[L,J]:=MATFORTES[L,J]+MATBITD[J];
               END;
         K:=0;
         FOR L:=1 TO NBOBJ DO
               BEGIN
               IF L MOD NBBITS=0 THEN K:=K+1;
               IF L MOD NBBITS IN MATBITD[K] THEN
                  FOR J:=0 TO DIMENSION DO
                   MATFORTES[L,J]:=MATFORTES[L,J]+MATBITG[J];
               END;
         END;
      END;   (* AJUSTE *)
      PROCEDURE CHERCHE(I:INTEGER);
      BEGIN
      WITH MATBITS[I] DO
         BEGIN
         IF MEMBRE(MATBITG) THEN CHERCHE(MAT[I].PTRGAUCHE)
         ELSE
            BEGIN
            IF MEMBRE(MATBITD) THEN CHERCHE(MAT[I].PTRDROIT)
            ELSE AJUSTE(I);
            END;
         END;
      END;   (* FIN CHERCHE *)
 
   BEGIN
   RESET(FICHTRI);
   FOR I:=1 TO NBOBJ DO
      FOR J:=0 TO DIMENSION DO MATFORTES[I,J]:=[];
   NBFAITS:=1;
   WHILE NBFAITS < NBOBJ DO
         BEGIN
         VALEUR:=FICHTRI@;
         GET(FICHTRI);
         WITH VALEUR DO
               BEGIN
               GAUCHE:=INT DIV FACTMULT;
               DROITE:=INT MOD FACTMULT;
               ADDRBIT1:=DROITE MOD NBBITS;
               ADDRSET1:=DROITE DIV NBBITS;
               IF CANDIDAT THEN
                     BEGIN
                     ADDRBIT2:=GAUCHE MOD NBBITS;
                     ADDRSET2:=GAUCHE DIV NBBITS;
                     CHERCHE(OBJ);
                     NBFAITS:=NBFAITS+1;
                     END;
               END;
         END;
   END;   (* CALCULE DIST *)
 
   PROCEDURE ECRITLIGNE(I:INTEGER;GAUCHE:BOOLEAN);
   VAR OBJ1,OBJ2:INTEGER;
   BEGIN
   IF GAUCHE THEN
      BEGIN
      WRITE(SORTIEC,ESPACE,1-MAT[I].RESULTAT:10:5);     (* Niveau = D *)
      WITH MATBITS[I].MATDIST DO
            BEGIN
            WRITE(SORTIEC,1-RESULTAT:10:5,'  (');       (* Niveau = D *)
            OBJ1:=INT DIV FACTMULT;
            OBJ2:=INT MOD FACTMULT;
            IF TITRE THEN WRITE(SORTIEC,IDENTIFICATEUR
                     [OBJ1],' , ',IDENTIFICATEUR[OBJ2])
            ELSE WRITE(SORTIEC,OBJ2:3,' ,',OBJ1:3);
            WRITELN(SORTIEC,')');
            END;
      END;
   END; (* FIN ECRITLIGNE *)
 
   PROCEDURE ECRIT(I,APPELANT:INTEGER;GAUCHE:BOOLEAN);
   BEGIN
   IF I>MAXNOBJ THEN WITH MAT[I] DO
         BEGIN
         ECRIT(PTRGAUCHE,I,TRUE);
         ECRITLIGNE(APPELANT,GAUCHE);
         ECRIT(PTRDROIT,I,FALSE);
         END
   ELSE ECRITLIGNE(APPELANT,GAUCHE);
   END;          (* FIN ECRIT *)
 
BEGIN  (* LIENS PRIMAIRES *)
WRITELN(SORTIEC);
WRITELN(SORTIEC,'1');
IF LANG=1 THEN WRITELN(SORTIEC,' L I E N S   P R I M A I R E S')
ELSE WRITELN(SORTIEC,' M I N I M U M   S P A N N I N G   T R E E');
WRITELN(SORTIEC);
IF TESTGR THEN BEGIN WRITELN(SORTIEC);WRITELN(SORTIEC);END;
IF LANG=1 THEN WRITE(SORTIEC,'   NIVEAU(D)  DISTANCE  ')
          ELSE WRITE(SORTIEC,'    LEVEL(D)  DISTANCE  ');
IF TITRE THEN WRITE(SORTIEC,'     ');
IF LANG=1 THEN WRITELN(SORTIEC,'  CHAINE')
          ELSE WRITELN(SORTIEC,'  CHAIN ');
WRITE(SORTIEC,ESPACE);
FOR I:=1 TO 32 DO WRITE(SORTIEC,TIRET);
IF TITRE THEN WRITE(SORTIEC,'--------------');
WRITELN(SORTIEC);WRITELN(SORTIEC);
ARBORESCENCE(OBJ,MATBITS[OBJ+1].MATBITG);
CALCULEDIST;
ECRIT(OBJ,OBJ,FALSE);
END;   (* LIENS PRIMAIRES *)
 
 (********************************************************************)
 (*             DENDROGRAMME                                         *)
 (********************************************************************)
PROCEDURE DENDRO(VAR MATOCC,PTRPTR:MATINT);
VAR I,J,K,NOBJPRIME:INTEGER;
 
   FUNCTION ADRESSE(X:REAL):INTEGER;
   BEGIN
   ADRESSE:=ROUND((1-X)/PAS);
   END;
 
   PROCEDURE DESSINE(LIMG,LIMD:INTEGER;GAUCHE:BOOLEAN);
   VAR I,J,L:INTEGER;
       X,Y,Z:REAL;
 
      PROCEDURE CHECK(A,B:INTEGER;CAR:CHAR);
      VAR K:INTEGER;
      BEGIN
      FOR K:=A TO B DO
         IF MATOCC[K] <= 0 THEN WRITE(SORTIEC,CAR)
         ELSE WRITE(SORTIEC,EXCLAM);
      END;  (* CHECK *)
 
   BEGIN
   IF LIMG > MAXNOBJ THEN
         BEGIN
         WRITE(SORTIEC,'            ');
         Y:=MAT[LIMG].RESULTAT;
         I:=ADRESSE(Y);
         END
   ELSE
         BEGIN
         IF TITRE THEN WRITE(SORTIEC,ESPACE,IDENTIFICATEUR[LIMG])
         ELSE WRITE(SORTIEC,LIMG:11);
         WRITE(SORTIEC,ESPACE);
         I:=0;Y:=1;
         END;
   Z:=MAT[LIMD].RESULTAT;
   J:=ADRESSE(Z);
   L:=J;
   IF NOT(GAUCHE) THEN MATOCC[J]:=MATOCC[J]-1;
   IF Y < Z THEN
      BEGIN
      IF I=J THEN J:=J-1;
      CHECK(0,J-1,ESPACE);
      CHECK(J,I-2,TIRET);
      WRITE(SORTIEC,'>',EXCLAM);
      CHECK(I+1,LIMITE,ESPACE);
      END
   ELSE
      BEGIN
      CHECK(0,I-1,ESPACE);
      WRITE(SORTIEC,EXCLAM,'<');
      CHECK(I+2,J,TIRET);
      IF I=J THEN J:=J+1;
      CHECK(J+1,LIMITE,ESPACE);
      END;
      IF GAUCHE THEN
            BEGIN
            WRITE(SORTIEC,1-Z:10:5);                    (* Niveau = D *)
            IF TESTGR THEN
                  BEGIN
                  X:=TEST@[LIMD];
                  IF X >= 0 THEN WRITE(SORTIEC,X:10:5);
                  END;
            END;
   WRITELN(SORTIEC);
   IF GAUCHE THEN MATOCC[L]:=MATOCC[L]+1;
   END;
 
FUNCTION FOUILLEBINAIRE(X:REAL):INTEGER;
VAR I,M,M2:INTEGER;
    Y:REAL;
BEGIN
I:=(NBLIGNES+1) DIV 2;
M:=(NBLIGNES) DIV 2;
Y:=VALEUR[I];
WHILE X<>Y DO
      BEGIN
      M2:=(M+1) DIV 2;
      M:=M DIV 2;
      IF X<Y THEN I:=I-M2
      ELSE I:=I+M2;
      Y:=VALEUR[I];
      END;
FOUILLEBINAIRE:=I;
END;   (* FIN FOUILLE BINAIRE *)
 
PROCEDURE COPHEN(RESULTAT:REAL);
VAR J,K,JPRIME,KPRIME,CLASSE:INTEGER;
    X,Y,Z:REAL;
BEGIN
IF TESTAPOSTERIORI THEN
   BEGIN
   CLASSE:=FOUILLEBINAIRE(RESULTAT);
   FOR J:=PTRPTR[NBPTRS-2]+1 TO PTRPTR[NBPTRS-1] DO
      BEGIN
      JPRIME:=MATPTR@[J]-1;
      FOR K:=PTRPTR[NBPTRS-1]+1 TO PTRPTR[NBPTRS] DO
         BEGIN
         KPRIME:=MATPTR@[K]-1;
         IF JPRIME>KPRIME THEN
               KPRIME:=JPRIME*(JPRIME-1) DIV 2 +KPRIME
               ELSE KPRIME:=KPRIME*(KPRIME-1) DIV 2 +JPRIME;
         MATSIM@[KPRIME+1]:=CLASSE;
         END;
      END;
   X:=PTRPTR[NBPTRS]-PTRPTR[NBPTRS-1];
   Y:=PTRPTR[NBPTRS-1]-PTRPTR[NBPTRS-2];
   Z:=X+Y;
   MATENTROPIE[CLASSE]:=MATENTROPIE[CLASSE]-X*LN(X)-Y*LN(Y)+Z*LN(Z);
   NBPTRS:=NBPTRS-1;
   PTRPTR[NBPTRS]:=PTRPTR[NBPTRS+1];
   END;
END;(* COPHEN *)
 
   PROCEDURE DIMIN(I,APPELANT:INTEGER;GAUCHE:BOOLEAN);
   BEGIN
   DESSINE(I,APPELANT,GAUCHE);
   IF TESTAPOSTERIORI THEN
      BEGIN
      NOBJPRIME:=NOBJPRIME+1;
      NBPTRS:=NBPTRS+1;
      MATPTR@[NOBJPRIME]:=I;
      PTRPTR[NBPTRS]:=NOBJPRIME;
      END;
   END;(* DIMIN *)
 
   PROCEDURE DENDROGRAMME(I,APPELANT:INTEGER;GAUCHE:BOOLEAN);
   BEGIN
   IF I > MAXNOBJ THEN WITH MAT[I] DO
         BEGIN
         DENDROGRAMME(PTRGAUCHE,I,TRUE);
         DESSINE(I,APPELANT,GAUCHE);
         DENDROGRAMME(PTRDROIT,I,FALSE);
         COPHEN(RESULTAT);
         END
   ELSE DIMIN(I,APPELANT,GAUCHE);
   END;   (* FIN DENDROGRAMME *)
 
BEGIN    (* DENDRO *)
WRITELN(SORTIEC,'1');
IF LANG=1 THEN WRITELN(SORTIEC,' D E N D R O G R A M M E')
          ELSE WRITELN(SORTIEC,' D E N D R O G R A M    ');
WRITELN(SORTIEC);
IF TESTGR THEN
      BEGIN
IF LANG=1 THEN
      WRITELN(SORTIEC,' T E S T S   S U R   L E S   G R O U P E S')
ELSE  WRITELN(SORTIEC,' T E S T S   A M O N G   G R O U P S');
      WRITELN(SORTIEC);
      END;
IF LANG=1 THEN WRITE(SORTIEC,ESPACE:10+LIMITE,'    NIVEAU(D)  ')
          ELSE WRITE(SORTIEC,ESPACE:10+LIMITE,'     LEVEL(D)  ');
IF TESTGR THEN WRITE(SORTIEC,'  TESTS');
WRITELN(SORTIEC);
WRITE(SORTIEC,ESPACE);
FOR I:=LIMITE+10 DOWNTO 0 DO WRITE(SORTIEC,TIRET);
IF TESTGR THEN WRITE(SORTIEC,'----------');
WRITELN(SORTIEC,'-----------');
WRITELN(SORTIEC);
NOBJPRIME:=0;
FOR I:=1 TO LIMITE DO MATOCC[I]:=0;
MAT[OBJ+1].RESULTAT:=MAT[OBJ].RESULTAT-PAS;
MATOCC[ADRESSE(MAT[OBJ+1].RESULTAT)]:=0;
IF TESTAPOSTERIORI THEN NEW(MATSIM);
DENDROGRAMME(OBJ,OBJ+1,FALSE);
END;     (* DENDRO *)
 
PROCEDURE PARAM;
VAR MINIMUM,MAXIMUM,I:INTEGER;
    X:REAL;
BEGIN
LIMITE:=0;
IF LANG=1 THEN
WRITELN(' VOULEZ-VOUS LA CHAINE DES LIENS PRIMAIRES ( o ou n) ? ')
ELSE WRITELN(' DO YOU WANT THE MINIMUM SPANNING TREE? ( y or n) ? ');
WHILE NOT (INPUT@ IN ['0','O','o','Y','y','N','n']) DO GET(INPUT);
LIENSPRI:=INPUT@ IN ['O','0','o','Y','y'];READLN;
testgr:=false;  (* Remove this statement if next 8 lines are put back *)
(* This experimental function has been disabled in this version of
the program.
IF LANG=1 THEN
WRITELN(' VOULEZ-VOUS LES TESTS EN COURS DE GROUPEMENT (o ou n) ? ')
ELSE
WRITELN(' DO YOU WANT THE TESTS DURING GROUP FORMATION (y or n) ? ');
WHILE NOT (INPUT@ IN ['0','O','o','Y','y','N','n']) DO GET(INPUT);
TESTGR:=INPUT@ IN ['O','0','o','Y','y'];READLN;                    *)
TESTAPOSTERIORI:=FALSE;
IF NBOBJ < MAXCORR THEN
 BEGIN
 IF LANG=1 THEN BEGIN
 WRITELN(' VOULEZ-VOUS LES TESTS A POSTERIORI:');
 WRITELN(' CORRELATIONS COPHENETIQUES, DISTANCE DE GOWER ET ENTROPIE?');
 END ELSE BEGIN
 WRITELN(' DO YOU WANT THE A POSTERIORI TESTS:');
 WRITELN(' COPHENETIC CORRELATIONS, GOWER''S DISTANCE AND ENTROPY ?');
 END;
 WHILE NOT (INPUT@ IN ['0','O','o','Y','y','N','n']) DO GET(INPUT);
 TESTAPOSTERIORI:=INPUT@ IN['0','O','o','Y','y'];READLN;
 END;
MAXIMUM:=NOBJ-1;
IF TESTGR THEN MINIMUM:=40
ELSE MINIMUM:=30;
   MINIMUM:=10;
REPEAT
   IF LANG=1 THEN BEGIN
   WRITE(' LARGEUR DU DENDROGRAMME EN CARACTERES (MINIMUM',MINIMUM:4);
   WRITELN(', MAXIMUM',MAXIMUM:4,')   ');
   END ELSE BEGIN
   WRITE(' WIDTH OF THE DENDROGRAM IN CHARACTERS (MINIMUM',MINIMUM:4);
   WRITELN(', MAXIMUM',MAXIMUM:4,')   ');
   END;READLN(LIMITE);
UNTIL (LIMITE >=MINIMUM)AND(LIMITE <=MAXIMUM);
PAS:=(1-MIN)/LIMITE;
IF TESTAPOSTERIORI THEN
   BEGIN
   SHELLSORT(VALEUR,OBJ-MAXNOBJ);
   NBLIGNES:=1;
   J:=NBOBJ-1;
   X:=VALEUR[1];
   FOR I:=2 TO J  DO
      BEGIN
      IF VALEUR[I]<>X THEN
            BEGIN
            VALEUR[NBLIGNES]:=X;
            NBLIGNES:=NBLIGNES+1;
            X:=VALEUR[I];
            END;
      END;
   VALEUR[NBLIGNES]:=X;
   FOR I:=1 TO NBLIGNES DO MATENTROPIE[I]:=0;
   NBPTRS:=0;
   END;
WRITELN(SORTIEC);
END;   (* PARAM *)
 
PROCEDURE LECTURE;
VAR I,J,K,KK:INTEGER;
 
   PROCEDURE ERREUR(I:INTEGER);
   BEGIN
   IF LANG=1 THEN BEGIN
   WRITE(' ERREUR: ');
   CASE I OF
     1:WRITELN(' FICHIER D ENTREE VIDE ');
     2:WRITELN(' ERREUR SUR LE FICHIER D ENTREE: NOMBRE D OBJETS <= 0');
     3:WRITELN(' TROP D OBJETS POUR LA CAPACITE DE CE PROGRAMME');
     4:WRITELN(' PAS DE FICHIER DE GROUPEMENT (SORTIEP)');
     END;
   END ELSE BEGIN
   WRITE(' ERROR: ');
   CASE I OF
     1:WRITELN(' EMPTY INPUT SIMILARITY FILE');
     2:WRITELN(' ERROR IN INPUT FILE: NUMBER OF OBJECTS <= 0');
     3:WRITELN(' TOO MANY OBJECTS. RE-DIMENSION THE PROGRAM');
     4:WRITELN(' NO CLUSTERING FILE (SORTIEP) IS PRESENT');
     END;
   END;
   GOTO 777;
   END;    (* FIN ERREUR *)
 
   PROCEDURE ECRITDATA;
   VAR I,J,K:INTEGER;
       TEMP:VARIABLE;
   BEGIN
   J:=0;
   FOR I:=1 TO NBMOTS DO
      BEGIN
      TEMP:=ENTREEC@;GET(ENTREEC);
      FOR K:=1 TO NBCAR DO
            BEGIN
            J:=J+1;
            IF J<=10 THEN WRITE(SORTIEC,TEMP.CAR[K]);
            END;
      END;
   END;  (* ECRITDATA *)
 
BEGIN
REWRITE(SORTIEC);
IF LANG=1 THEN BEGIN
WRITELN(SORTIEC,' P R O G R A M M E   D E N D R O');
WRITELN(SORTIEC);WRITELN(SORTIEC,' Logiciel R, Version 3.0b');
END ELSE BEGIN
WRITELN(SORTIEC,' P R O G R A M   D E N D R O  to plot dendrograms.');
WRITELN(SORTIEC);WRITELN(SORTIEC,' Version 3.0b');
END;
WRITELN(SORTIEC);
RESET(ENTREEC);
IF EOF(ENTREEC) THEN ERREUR(1);
TEMP:=ENTREEC@;NBOBJ:=TEMP.INT;
IF NBOBJ<=0 THEN ERREUR(2)
ELSE IF NBOBJ > NOBJ THEN ERREUR(3);
RESET(SORTIEP);
IF EOF(SORTIEP) THEN ERREUR(4);
MIN:=SORTIEP@.RESULTAT;
OBJ:=MAXNOBJ+NBOBJ-1;
FOR I:=MAXNOBJ1 TO OBJ DO
      BEGIN
      WITH SORTIEP@ DO
            BEGIN
            IF RESULTAT < MIN THEN MIN:=RESULTAT;
            IF NBOBJ < MAXCORR THEN VALEUR[I-MAXNOBJ]:=RESULTAT;
            END;
      MAT[I]:=SORTIEP@;GET(SORTIEP);
      END;
MAT[OBJ+1]:=MAT[OBJ];
DIMENSION:=NBOBJ DIV NBBITS;
IF LANG=1 THEN WRITELN(SORTIEC,' NOMBRE D OBJETS :',NBOBJ:5)
          ELSE WRITELN(SORTIEC,' NUMBER OF OBJECTS :',NBOBJ:5);
GET(ENTREEC);
TEMP:=ENTREEC@;GET(ENTREEC);
IF LANG=1 THEN WRITELN(SORTIEC,' NOMBRE DE VARIABLES:',TEMP.INT:5)
          ELSE WRITELN(SORTIEC,' NUMBER OF VARIABLES:',TEMP.INT:5);
IF LANG=1 THEN WRITE(SORTIEC,' TITRE: ')
          ELSE WRITE(SORTIEC,' TITLE: ');
FOR I:=1 TO 10 DO ECRITDATA;
WRITELN(SORTIEC);
WRITE(SORTIEC,' DATE ');
ECRITDATA;
WRITELN(SORTIEC);
IF LANG=1 THEN WRITE(SORTIEC,' FONCTION ')
          ELSE WRITE(SORTIEC,' FUNCTION ');
ECRITDATA;
ECRITDATA;
WRITELN(SORTIEC);
WRITELN(SORTIEC);
TEMP:=ENTREEC@;
TITRE:=TEMP.INT<>0;
IF TITRE THEN
      BEGIN
      FOR I:=1 TO NBOBJ DO
            BEGIN
            K:=0;
            GET(ENTREEC);
            TEMP:=ENTREEC@;
            FOR J:=1 TO 10 DO
                  BEGIN
                  K:=K+1;
                  IDENTIFICATEUR[I,J]:=TEMP.CAR[K];
                  IF ((K=NBCAR)AND(J<>10)) THEN
                        BEGIN
                        K:=0;
                        GET(ENTREEC);
                        TEMP:=ENTREEC@;
                        END;
                  END;
            END;
      END;
END;          (* FIN LECTURE *)
 
BEGIN (* Prog. princ. *)
WRITELN;WRITELN;
IF LANG=1 THEN BEGIN
WRITELN(' P R O G R A M M E   D E N D R O ');
WRITELN;WRITELN;WRITELN
(' Dendrogramme, chaine des liens primaires, tests entre les groupes');
WRITELN(' Version 3.0b');
WRITELN(' AUTEUR: A. VAUDOR');
END ELSE BEGIN
WRITELN(' P R O G R A M   D E N D R O ');
WRITELN;WRITELN;
WRITELN(' Dendrogram, minimum spanning tree, tests during clustering');
WRITELN(' Version 3.0b');
WRITELN(' AUTHOR: A. VAUDOR');END;
WRITELN;
LECTURE;
PARAM;
IF TESTGR THEN
      BEGIN
      NEW(PTRDONNEE);
      INVERSE(PTRDONNEE@);
      DISPOSE(PTRDONNEE);
      NEW(TEST);
      NEW(POSITION);
      NEW(MATNOEUD);
      TESTSGROUPES(TEST@,POSITION@,MATNOEUD@);
      DISPOSE(POSITION);
      DISPOSE(MATNOEUD);
      END;
NEW(MATOCC);
NEW(PTRPTR);
PTRPTR@[0]:=0;PTRPTR@[-1]:=0;
IF TESTAPOSTERIORI THEN NEW(MATPTR);
DENDRO(MATOCC@,PTRPTR@);
DISPOSE(MATOCC);
IF TESTAPOSTERIORI THEN DISPOSE(MATPTR);
IF TESTGR THEN DISPOSE(TEST);
IF LIENSPRI THEN
      BEGIN
      NEW(MATBITS);
      LIENSPRIMAIRES(MATBITS@);
      DISPOSE(MATBITS);
      END;
IF TESTAPOSTERIORI THEN
      BEGIN
      TESTS(PTRPTR@);
      END;
777:IF LANG=1 THEN WRITELN(' Fin du programme.')
ELSE WRITELN(' End of the program.');
END.
