PROGRAM SORTRI(ENTREEB,FICHTRI,OUTPUT);
(* ================================================================== *)
(*     This program is used before CHRONO, INTERLNK (LIENINT),        *)
(*             and DENDRO to sort the SIMIL input file.               *)
(*     ENTREEB is the input SIMIL file.                               *)
(*     FICHTRI is the output file of this program. It contains        *)
(*             (in binary form) the values of the similarity file,    *)
(*             sorted in order of decreasing similarities.            *)
(*     OUTPUT is the user's terminal.                                 *)
(* ================================================================== *)
CONST MAXIMUM=10000;
      MAXIMU1=10001;      (* MAXIMUM + 1 *)
      NBMOTS=1;
      NBCAR=10;           (*NBCAR X NBMOTS>=10 *)
      FACTMULT=16384;     (* =2 to the power 14 *)
      MAXREEL=1.70E38;    (* modify according to your computer *)
TYPE DATA=RECORD
                REE:REAL;
                INT:INTEGER;
                END;
      MATRICE=ARRAY[1..MAXIMU1] OF DATA;
      DATA1=RECORD CASE INTEGER OF
            1:(RE:REAL);
            2:(INT:INTEGER);
            3:(MATCAR:PACKED ARRAY[1..NBCAR] OF CHAR);
            END;
      FICH=FILE OF DATA;
VAR I,J,K,L,LIMITE,NOBJ,NOBJ1,IMPAIR,LIGNE,COLONNE: INTEGER;
    DONNEE:DATA1;
    MAT:MATRICE;
    FICHTRI,TEMP:FICH;
    ENTREEB:FILE OF DATA1;

PROCEDURE SHELLSORT(VAR A: MATRICE;N: INTEGER);
LABEL 1;
VAR I,J,K,L,M,O: INTEGER;
    W:DATA;
BEGIN
M:=(2*N-1) DIV 2;
WHILE M<>0 DO
        BEGIN
        K:=N-M;
        FOR J:=1 TO K DO
                BEGIN
                I:=J;
                WHILE I>=1 DO
                        BEGIN
                        IF A[I+M].REE<=A[I].REE THEN GOTO 1;
                        O:=I+M;
                        W:=A[I];A[I]:=A[O];A[O]:=W;
                        I:=I-M;
                        END;
1:                 END;
        M:=M  DIV 2;
        END;
END;        (* FIN DE SHELLSORT *)

PROCEDURE SORTMRG(VAR FICH1,FICH2:FICH;FILEINIT:BOOLEAN;    (* Modif. 91.02.18*)
                  VAR MAT:MATRICE; LIM:INTEGER);
VAR I,J,K:INTEGER;
    X:REAL;
    DONNEE:DATA;
BEGIN
J:=1;
IF NOT (FILEINIT) THEN RESET(FICH2);                        (* Modif. 91.02.18*)
REWRITE(FICH1);
WHILE (J<=LIMITE) DO
      BEGIN
      IF NOT(EOF(FICH2)) THEN(* Modif. 91.02.18*)
      WHILE ((FICH2@.REE>=MAT[J].REE)AND(NOT(EOF(FICH2)))) DO
            BEGIN
            FICH1@:=FICH2@;
            PUT(FICH1);GET(FICH2);
            END;
      IF EOF(FICH2) THEN X:=-(MAXREEL) ELSE X:=FICH2@.REE;  (* Modif. 91.02.18*)
      WHILE ((MAT[J].REE>X)AND(J<=LIMITE)) DO
            BEGIN
            FICH1@:=MAT[J];
            PUT(FICH1);
            J:=J+1;
            END;
      END;
WHILE (NOT(EOF(FICH2))) DO BEGIN FICH1@:=FICH2@;PUT(FICH1);GET(FICH2);END;
	(* Modif. 91.02.18*)
END;        (* FIN SORTMRG *)

BEGIN       (* DEBUT PROG PRINC *)
REWRITE(TEMP);REWRITE(FICHTRI);                             (* Modif. 91.02.18*)
RESET(ENTREEB);
LIGNE:=1;
COLONNE:=2;
DONNEE:=ENTREEB@;
NOBJ:=DONNEE.INT;
GET(ENTREEB);GET(ENTREEB);
FOR I:=1 TO 13 DO
   FOR J:=1 TO NBMOTS DO GET(ENTREEB);
DONNEE:=ENTREEB@;
GET(ENTREEB);
IF DONNEE.INT<>0 THEN FOR I:=1 TO NOBJ DO
                         FOR J:=1 TO NBMOTS DO GET(ENTREEB);
NOBJ1:=NOBJ*(NOBJ-1) DIV 2;
IMPAIR:=(NOBJ1 DIV MAXIMUM) MOD 2;
FOR I:=0 TO NOBJ1 DIV MAXIMUM DO
      BEGIN
      IF (I+1)*MAXIMUM<NOBJ1 THEN LIMITE:=MAXIMUM
      ELSE LIMITE:=NOBJ1 MOD MAXIMUM;
      MAT[LIMITE+1].REE:=0;
      FOR J:=1 TO LIMITE DO
            BEGIN
            DONNEE:=ENTREEB@;
            GET(ENTREEB);
            MAT[J].REE:=DONNEE.RE;
            (* ENTRER LES ID *)
            MAT[J].INT:=FACTMULT*COLONNE+LIGNE;
            COLONNE:=COLONNE+1;
            IF COLONNE > NOBJ THEN
                  BEGIN
                  LIGNE:=LIGNE+1;
                  COLONNE:=LIGNE+1;
                  END;
            END;
      SHELLSORT(MAT,LIMITE);
      IF I MOD 2=IMPAIR THEN
       SORTMRG(FICHTRI,TEMP,I=0,MAT,LIMITE)                 (* Modif. 91.02.18*)
      ELSE SORTMRG(TEMP,FICHTRI,I=0,MAT,LIMITE);            (* Modif. 91.02.18*)
      END;
END.
